/*
    Copyright 2010 Luis Miguel Merino Bonilla

    This file is part of GNU Taste

    GNU Taste is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GNU Taste is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with GNU Taste. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef 
__FEATURE_VECTOR__
#define __FEATURE_VECTOR__

#include "list.h"
#include <iostream>

using namespace std;

class feature_vector{
private:
	// Hay que probar una implementación con una slist debajo, 
	// a ver como se comporta en caché
	float sum;
	int count;
public:
	list *vector;
	feature_vector() :count(0),sum(0) { 
		vector = list_new();
	}
	~feature_vector() { }
	
	inline void insert(int item, float value){
		list_push(vector, item, value);
		sum += value;
		++count;
	}

	void normalize_ratings(){
		node *b = list_begin(vector);
		for(; b != 0; next(b))
		    	b->value -= mean();
	}
	
	inline float mean(){
		return sum/count;
	}
	
	inline node * begin(){
		return list_begin(vector);
	}
	
	void sort(){
		list_sort(vector);
	}

	friend ostream &operator<<(ostream &stream, feature_vector & ob);
	friend istream &operator>>(istream &stream, feature_vector & ob);

};

ostream &operator<<(ostream &stream, feature_vector & ob){
  stream << ob.vector;
  return stream;
}

istream &operator>>(istream &stream, feature_vector & ob){
  stream >> ob.vector;
  return stream;
}
#endif
