#include "database.h"
#include "knn_item.h"
#include "log.h"
#include <iostream>
#include <fstream>
#include <cstring>

using namespace std;

int main(int argc, char * argv[]){
	Database *db = new Database(argv[1]);

	if(string(argv[2]) == string("load")){
		db->loadStats();
		Loader *l = new MovielensLoader(db);
		l->load(argv[3]);
		db->saveToStore();
	}

	//Muestra la información del objeto seleccionado
	if(string(argv[2]) == string("show")){
		feature_vector * ob = db->getUser(atoi(argv[3]));
		if(ob)
			cout << *ob << endl;
		else
			cout << "Objeto no encontrado." << endl;

		db->show();

	}

	//Emite una predicción para un usuario y un conjunto de items
	if(string(argv[2]) == string("predict")){
		//Hay que revisar la carga de estadisticas
		//Esto es super pesao y no es necesario hacerlo asi
		//Donde almacenamos la info? por separado?
		db->loadStats();
		KNN *k = new KNN(db);

		int user = atoi(argv[3]);
		int numItems = argc-4;
		
		for(int i=0; i<numItems; ++i){ //Para cada item indicado en la cadena de comandos
			int item = atoi(argv[4+i]);
			float prediction = k->predict(user,item);
			cout << user << " " << item << " " << prediction << endl;
		}
	}

	//Calcula la tabla de similitud del articulo
	if(string(argv[2]) == string("sim_table")){
		//Hay que revisar la carga de estadisticas
		//Esto es super pesao y no es necesario hacerlo asi
		//Donde almacenamos la info? por separado?
		db->loadStats();
		KNN *k = new KNN(db);

		int item = atoi(argv[3]);
		Hash<float> & table = k->simTable(item);
		for(Hash<float>::Iterator it = table.begin(); !it.end(); ++it){
			cout << it->key << " " << it->value << endl;
		}
	}


	//Muestra la información del objeto seleccionado
	if(string(argv[2]) == string("test")){
		db->loadStats();
		KNN *k = new KNN(db);

		FILE *f_test = fopen(argv[3], "r");
		int user, item, tstamp;
		float value;

		log(string("Procesando fichero de ratings ") + string(argv[3]));

		float error = 0;
		int counter = 0;
		int counter2 = 0;
//		while (fscanf(f_test, "%d %d %f %d",&user,&item,&value,&tstamp) != EOF){
		while (fscanf(f_test, "%d::%d::%f::%d",&user,&item,&value,&tstamp) != EOF){
			//cout << counter << endl;
			float p = k->predict(user,item);
			++counter2;
			if (p){
				error += abs(p - value);
				if(++counter % 2000 == 0){	
						cout << counter << endl;
						log("");
				}
			}
		}
		cout << "("<<counter<<"/"<<counter2<<") MAE: " << error/counter << endl;
	}

}
